package com.platform.controller;

import java.util.List;
import java.util.Map;

import com.platform.annotation.CanUserUpdateRecord;
import com.platform.entity.Result;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.platform.entity.CouponGoodsEntity;
import com.platform.service.CouponGoodsService;
import com.platform.utils.PageUtils;
import com.platform.utils.Query;


/**
 * 优惠券关联商品Controller
 *
 * @author lipengjun
 * @email 939961241@qq.com
 * @date 2017-08-29 21:50:17
 */
@RestController
@RequestMapping("coupongoods")
public class CouponGoodsController {
    @Autowired
    private CouponGoodsService couponGoodsService;

    /**
     * 查看列表
     */
    @RequestMapping("/list")

    public Result list(@RequestBody Map<String, Object> params) {
        //查询列表数据
        Query query = new Query(params);

        List<CouponGoodsEntity> couponGoodsList = couponGoodsService.queryList(query);
        int total = couponGoodsService.queryTotal(query);

        PageUtils pageUtil = new PageUtils(couponGoodsList, total, query.getLimit(), query.getPage());

        return Result.success(pageUtil);
    }

    /**
     * 查看信息
     */
    @RequestMapping("/info/{id}")

    public Result info(@PathVariable("id") Integer id) {
        CouponGoodsEntity couponGoods = couponGoodsService.queryObject(id);

        return Result.success( couponGoods);
    }

    /**
     * 保存
     */
    @CanUserUpdateRecord
    @RequestMapping("/save")

    public Result save(@RequestBody CouponGoodsEntity couponGoods) {
        couponGoodsService.save(couponGoods);

        return Result.success();
    }

    /**
     * 修改
     */
    @CanUserUpdateRecord
    @RequestMapping("/update")

    public Result update(@RequestBody CouponGoodsEntity couponGoods) {
        couponGoodsService.update(couponGoods);

        return Result.success();
    }

    /**
     * 删除
     */
    @CanUserUpdateRecord
    @RequestMapping("/delete")

    public Result delete(@RequestBody Integer[]ids) {
        couponGoodsService.deleteBatch(ids);

        return Result.success();
    }

    /**
     * 查看所有列表
     */
    @RequestMapping("/queryAll")
    public Result queryAll(@RequestBody Map<String, Object> params) {

        List<CouponGoodsEntity> list = couponGoodsService.queryList(params);

        return Result.success( list);
    }
}
